=== debian/changelog ===
cantata (3.3.1.ds1-1) unstable; urgency=medium

  * New upstream version.
    - use new upstream source at https://github.com/nullobsi/cantata
    - refresh patches, dropping those applied upstream
    - fixes FTBFS with CMake 4 (Closes: #1112761)
  * Update Standards-Version to 4.7.2 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Sun, 28 Sep 2025 11:24:19 +1000

cantata (2.5.0.ds1-4) unstable; urgency=medium

  * Add patch to fix FTBFS with taglib 2.0 (Closes: #1092685).

 -- Stuart Prescott <stuart@debian.org>  Sat, 11 Jan 2025 16:25:53 +1100

cantata (2.5.0.ds1-3) unstable; urgency=medium

  * Fix FTBFS with ffmpeg 7.0 with patch (Closes: #1072403).
  * Switch from pkg-config to pkgconf.
  * Update Standards-Version to 4.7.0 (no changes required).
  * Update copyright hints and regenerate.
  * Restore incorrectly deleted debian/source/lintian-overrides.

 -- Stuart Prescott <stuart@debian.org>  Mon, 03 Jun 2024 18:20:40 +1000
