=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=6

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf6

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_REMOTE_DEVICES=OFF

execute_after_dh_installexamples:
	chmod -x $(CURDIR)/debian/cantata/usr/share/doc/cantata/examples/cantata-dynamic.service
