=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/[.+]ds[0-9]//
Owner: nullobsi
Project: cantata
Repacksuffix: .ds1
