## cantata 3.4.0.ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
     Cantata
-    VERSION "3.3.1"
+    VERSION "3.4.0"
     DESCRIPTION "Graphical MPD Client with Qt."
     HOMEPAGE_URL "https://github.com/nullobsi/cantata"
     LANGUAGES CXX C
@@ -78,7 +78,7 @@
     set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
     set(MACOSX_BUNDLE_VERSION ${PROJECT_VERSION})
     set(MACOSX_BUNDLE_COPYRIGHT "Copyright © 2024 Cantata Contributors.")
-    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${PROJECT_ID})
+	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${PROJECT_REV_ID})
     set(MACOSX_BUNDLE_EXECUTABLE cantata)
     set(MACOSX_BUNDLE_ICON_FILE cantata.icns)
     set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
@@ -143,13 +143,18 @@
     "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)"
     OFF
 )
-option(ENABLE_CATEGORIZED_VIEW "Enable support for categorised view" OFF)
 option(ENABLE_SCROBBLING "Enable scrobbling" ON)
 
 if(WIN32 OR APPLE OR HAIKU)
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
+	option(BUNDLED_KCATEGORIZEDVIEW "Compile vendored KCategorizedView" ON)
+	option(BUNDLED_KARCHIVE "Compile vendored KArchive" ON)
+	option(BUNDLED_FONTAWESOME "Use bundled QResources for FontAwesome." ON)
 else()
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
+	option(BUNDLED_KCATEGORIZEDVIEW "Compile vendored KCategorizedView" OFF)
+	option(BUNDLED_KARCHIVE "Compile vendored KArchive" OFF)
+	option(BUNDLED_FONTAWESOME "Use bundled QResources for FontAwesome." OFF)
     option(
         ENABLE_REMOTE_DEVICES
         "Enable support for remote (sshfs, samba) devices"
@@ -344,23 +349,20 @@
 
 if(APPLE)
     target_sources(cantata PRIVATE mac/dockmenu.cpp)
+
     find_package(IOKit)
-    if(IOKIT_FOUND)
-        target_link_libraries(cantata PRIVATE ${IOKIT_LIBRARY})
+    if(IOKit_FOUND)
+        target_link_libraries(cantata PRIVATE IOKit::IOKit)
         target_sources(cantata PRIVATE mac/powermanagement.cpp)
     endif()
+
     find_package(Foundation REQUIRED)
-    find_library(MAC_APPKIT_LIBRARY AppKit REQUIRED)
+    find_package(AppKit REQUIRED)
     target_link_libraries(
         cantata
-        PRIVATE ${FOUNDATION_LIBRARY} ${MAC_APPKIT_LIBRARY}
-    )
-    find_library(MAC_MEDIAPLAYER_LIBRARY MediaPlayer)
-    if(MAC_MEDIAPLAYER_LIBRARY)
+        PRIVATE Foundation::Foundation AppKit::AppKit
+    )
+
+    find_package(MediaPlayer)
+    if(MediaPlayer_FOUND)
         target_sources(cantata PRIVATE mac/macnowplaying.mm)
-        target_link_libraries(cantata PRIVATE ${MAC_MEDIAPLAYER_LIBRARY})
-        target_compile_definitions(cantata PRIVATE MAC_MEDIAPLAYER_FOUND)
-    endif()
-elseif(WIN32 AND QT_VERSION_MAJOR EQUAL 5)
-    find_package(Qt5 COMPONENTS WinExtras REQUIRED)
-    list(APPEND QT_COMPONENTS WinExtras)
