=== support/CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,9 @@
 set(SUPPORT_UIS shortcutssettingswidget.ui)
 
 qt_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
-qt_add_resources(SUPPORT_RC_SRCS QtAwesomeFree.qrc)
+if (BUNDLED_FONTAWESOME)
+	qt_add_resources(SUPPORT_RC_SRCS QtAwesomeFree.qrc)
+endif()
 
 add_library(
     support
