=== debian/changelog ===
cantata (3.4.0.ds1-1) unstable; urgency=medium

  * New upstream release.
    - drop patches, merged upstream
    - add new build-dep on libkf6archive-dev, libkf6itemviews-dev

 -- Stuart Prescott <stuart@debian.org>  Sat, 24 Jan 2026 13:35:42 +1100
