=== debian/control ===
--- 
+++ 
@@ -16,6 +16,8 @@
  libcdio-paranoia-dev,
  libdbus-1-dev,
  libebur128-dev,
+ libkf6archive-dev,
+ libkf6itemviews-dev,
  libmpg123-dev,
  libmtp-dev,
  libmusicbrainz5-dev,
